//  garbage.cs - Using a variable number of arguments 
//               of different types
//--------------------------------------------------------------------

using System;

public class Garbage
{
    public static void Print( params object[] args )
    {
       int ctr = 0;

       for( ctr = 0; ctr < args.Length; ctr++)
       {
          Console.WriteLine("Argument {0} is:  {1}", ctr, args[ctr]);
       }
    }
}

class MyApp
{
   public static void Main()
   {
      long ALong = 1234567890987654321L;
      decimal ADec = 1234.56M;
      byte Abyte = 42;
      string AString = "Cole McCrary";

      Console.WriteLine("First call...");
      Garbage.Print( 1 );   // pass a simple integer

      Console.WriteLine("\nSecond call...");
      Garbage.Print( );     // pass nothing

      Console.WriteLine("\nThird call...");
      Garbage.Print( ALong, ADec, Abyte, AString );  // Pass lots

      Console.WriteLine("\nFourth call...");
      Garbage.Print( AString, "is cool", '!' );      // more stuff
   }
}
