// throwmine.cs
// Throwing your own error.
//=============================================
using System;

class MyThreeException : Exception {}
class NegativeNumberException : Exception {}

class MyAppClass 
{
   public static void Main() 
   {
      int result;

      try
      {
          result = MyMath.AddEm( 1, 2 );
          Console.WriteLine( "Result of AddEm(1, 2) is {0}", result);

          result = MyMath.AddEm( 3, 4 );
          Console.WriteLine( "Result of AddEm(3, 4) is {0}", result);
      }

      catch (MyThreeException)
      {
          Console.WriteLine("Ack!  We don't like adding threes.");
      }

      catch (Exception e)
      {
         Console.WriteLine("Exception caught: {0}", e);
      }

      try
      {
          result = MyMath.SubtractEm( 10, 2 );
          Console.WriteLine( "Result of SubtractEm(10, 2) is {0}", result);

          result = MyMath.SubtractEm( 2, 10 );
          Console.WriteLine( "Result of SubractEm(2, 10) is {0}", result);
      }

      catch (NegativeNumberException msg)
      {
          Console.WriteLine("Sorry, you can't subtract to a result less than zero!");
          Console.WriteLine("\nPassed Error Message: \n{0}", msg);
      }

      catch (Exception e)
      {
         Console.WriteLine("Exception caught: {0}", e);
      }

      Console.WriteLine("At end of program");
   }
}

class MyMath
{
   static public int AddEm(int x, int y) 
   {
      if(x == 3 || y == 3)
         throw( new MyThreeException() );

      return( x + y );
   }

   static public int SubtractEm(int x, int y)
   {
      if( y > x )
         throw( new NegativeNumberException() );
     
      return( x - y );
   }
}
