// ListFile.cs - program to print a listing to the console
//-----------------------------------------------------------

using System;
using System.IO;

class ListFile
{
  public static void Main(string[] args)
  {
    try
    {

       int ctr=0;
       if (args.Length <= 0 )
       {
          Console.WriteLine("Format: ListFile filename");
          return;
       }
       else
       {
          FileStream fstr = new FileStream(args[0], FileMode.Open);
          try
          {
             StreamReader t = new StreamReader(fstr);
             string line;
             while ((line = t.ReadLine()) != null)
             {
                ctr++;
                Console.WriteLine("{0}:  {1}", ctr, line);
             }
          }
          catch( Exception e )
          {
             Console.WriteLine("Exception during read/write: {0}\n", e);
          }
          finally
          {
             fstr.Close();
          }
       }
    }

    catch (System.IO.FileNotFoundException)
    {
       Console.WriteLine ("ListFile could not find the file {0}", args[0]);
    }
    catch (Exception e)
    {
       Console.WriteLine("Exception: {0}\n\n", e);
    }
  }
}