// button1.cs - Working with buttons and events
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private Label myDateLabel;
   private Button btnUpdate;

   public frmApp()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
       this.Text = Environment.CommandLine;
       this.StartPosition = FormStartPosition.CenterScreen;
       this.FormBorderStyle = FormBorderStyle.Fixed3D;

       myDateLabel = new Label();      // Create label

       DateTime currDate = new DateTime();
       currDate = DateTime.Now;
       myDateLabel.Text = currDate.ToString();

       myDateLabel.AutoSize = true;
       myDateLabel.Location = new Point( 50, 20);
       myDateLabel.BackColor = this.BackColor;

       this.Controls.Add(myDateLabel);  // Add label to form

       // Set width of form based on Label's width
       this.Width = (myDateLabel.PreferredWidth + 100);

       btnUpdate = new Button();    // Create a button

       btnUpdate.Text = "Update";
       btnUpdate.BackColor = Color.LightGray;
       btnUpdate.Location = new Point(((this.Width/2) - (btnUpdate.Width / 2)),
                                      (this.Height - 75));

       this.Controls.Add(btnUpdate);  // Add button to form

       // Add a click event handler using the default event handler
       btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
       btnUpdate.MouseEnter += new System.EventHandler(this.btnUpdate_MouseEnter);
       btnUpdate.MouseLeave += new System.EventHandler(this.btnUpdate_MouseLeave);

       myDateLabel.MouseEnter += new System.EventHandler(this.myDataLabel_MouseEnter);
       myDateLabel.MouseLeave += new System.EventHandler(this.myDataLabel_MouseLeave);
   }

   protected void btnUpdate_Click( object sender, System.EventArgs e)
   {
       DateTime currDate = DateTime.Now;
       this.myDateLabel.Text = currDate.ToString();
   }

   protected void btnUpdate_MouseEnter( object sender, System.EventArgs e)
   {
       this.BackColor = Color.HotPink;
   }

   protected void btnUpdate_MouseLeave( object sender, System.EventArgs e)
   {
       this.BackColor = Color.Blue;
   }

   protected void myDataLabel_MouseEnter( object sender, System.EventArgs e)
   {
       this.BackColor = Color.Yellow;
   }

   protected void myDataLabel_MouseLeave( object sender, System.EventArgs e)
   {
       this.BackColor = Color.Green;
   }


   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
   }
}
