// canned.cs - using existing dialogs
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private MainMenu myMainMenu;

   public frmApp()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
      this.Text = "Canned Dialogs";
      this.StartPosition = FormStartPosition.CenterScreen;
      this.FormBorderStyle = FormBorderStyle.Sizable;
      this.Width = 400;

      myMainMenu = new MainMenu();
      
      MenuItem menuitemFile = myMainMenu.MenuItems.Add("&File");
      menuitemFile.MenuItems.Add(new MenuItem("Colors Dialog", 
                                 new EventHandler(this.Menu_Selection)));
      menuitemFile.MenuItems.Add(new MenuItem("Fonts Dialog", 
                                 new EventHandler(this.Menu_Selection)));
      menuitemFile.MenuItems.Add(new MenuItem("Print Preview Dialog",
                                 new EventHandler(this.Menu_Selection)));
      menuitemFile.MenuItems.Add("-");
      menuitemFile.MenuItems.Add(new MenuItem("Exit",
                                 new EventHandler(this.Menu_Selection)));
      this.Menu = myMainMenu;
   }

   protected void Menu_Selection( object sender, System.EventArgs e )
   {                                 
      switch (((MenuItem) sender).Text )
      {
        case "Exit":
             Application.Exit();
             break;

        case "Colors Dialog":
             ColorDialog myColorDialog = new ColorDialog();
             myColorDialog.ShowDialog();
             break;

        case "Fonts Dialog":
             FontDialog myFontDialog = new FontDialog();
             myFontDialog.ShowDialog();
             break;

        case "Print Preview Dialog":
             PrintPreviewDialog myPrintDialog =
                                    new PrintPreviewDialog();
             myPrintDialog.ShowDialog();
             break;
             
        default:
             MessageBox.Show("DEFAULT", "PopUp");
             break;
      }
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
   }
}
