// menu3.cs - menus
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private Label myDateLabel;
   private MainMenu myMainMenu;

   private MenuItem menuitemFile;
   private MenuItem menuitemUD;
   private MenuItem menuitemActive;
   private MenuItem menuitemExit;
   private MenuItem menuitemHelp;
   private MenuItem menuitemAbout;

   public frmApp()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
       this.Text = "STY Menus";
       this.StartPosition = FormStartPosition.CenterScreen;
       this.FormBorderStyle = FormBorderStyle.Sizable;

       myDateLabel = new Label();      // Create label

       DateTime currDate = new DateTime();
       currDate = DateTime.Now;
       myDateLabel.Text = currDate.ToString();

       myDateLabel.AutoSize = true;
       myDateLabel.Location = new Point( 50, 70);
       myDateLabel.BackColor = this.BackColor;

       this.Controls.Add(myDateLabel);  // Add label to form

       // Set width of form based on Label's width
       this.Width = (myDateLabel.PreferredWidth + 100);

       CreateMyMenu();
   }

   protected void MenuUpdate_Selection( object sender, System.EventArgs e)
   {
      if( menuitemActive.Checked == true)
      {
         DateTime currDate = new DateTime();
         currDate = DateTime.Now;
         this.myDateLabel.Text = currDate.ToString();
      }
      else
      {
         this.myDateLabel.Text = "** " + this.myDateLabel.Text + " **";
      }
   }

   protected void FileExit_Selection( object sender, System.EventArgs e)
   {
      Application.Exit();
   }

   protected void FileAbout_Selection( object sender, System.EventArgs e)
   {
      // display an about form
   }

   protected void ActiveMenu_Selection( object sender, System.EventArgs e)
   {
      MenuItem tmp = new MenuItem();
      tmp = (MenuItem) sender;

      if ( tmp.Checked == true )
         tmp.Checked = false;
      else
         tmp.Checked = true;
   }

   public void CreateMyMenu() 
   {
      myMainMenu = new MainMenu();

      // FILE MENU
      menuitemFile = myMainMenu.MenuItems.Add("&File");

      menuitemUD = new MenuItem();
      menuitemUD.Text = "Update &Date";
      menuitemUD.Shortcut = Shortcut.CtrlD;
      menuitemUD.Click += new EventHandler(this.MenuUpdate_Selection);
      menuitemFile.MenuItems.Add( menuitemUD ); 
                                  
      menuitemExit = new MenuItem();
      menuitemExit.Text = "E&xit";
      menuitemExit.Shortcut = Shortcut.CtrlX;
      menuitemExit.ShowShortcut = false;
      menuitemExit.Click += new EventHandler(this.FileExit_Selection);
      menuitemFile.MenuItems.Add( menuitemExit );
     
      // HELP MENU
      menuitemHelp = myMainMenu.MenuItems.Add("&Help");

      menuitemActive = new MenuItem();
      menuitemActive.Text = "Active";
      menuitemActive.Click += new EventHandler(this.ActiveMenu_Selection);
      menuitemActive.Checked = true;
      menuitemHelp.MenuItems.Add( menuitemActive );

      menuitemAbout = new MenuItem();
      menuitemAbout.Text = "&About";
      menuitemAbout.Shortcut = Shortcut.CtrlA;
      menuitemAbout.ShowShortcut = false;
      menuitemAbout.Click += new EventHandler(this.FileAbout_Selection);
      menuitemHelp.MenuItems.Add( menuitemAbout );

      this.Menu = myMainMenu;
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
   }
}
