// msgbox.cs - Using the MessageBox class
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private ContextMenu myPopUp;
                              
   public frmApp()
   {
      MessageBox.Show( "You have started the application.", "Status");
      InitializeComponent();
      CreatePopUp();
      MessageBox.Show( "Form has been initialized.", "Status");
   }                

   private void InitializeComponent()
   {
       this.Text = "STY C# Pop-up Menu";
       this.StartPosition = FormStartPosition.CenterScreen;
   }
                    
   protected void PopUp_Selection( object sender, System.EventArgs e)
   {
      // Determine menu item and do logic...
      MessageBox.Show( ((MenuItem) sender).Text, this.Text + " Msg Box");
   }

   private void CreatePopUp() 
   {
      myPopUp = new ContextMenu();

      myPopUp.MenuItems.Add("First Item",
                            new EventHandler(this.PopUp_Selection));
      myPopUp.MenuItems.Add("Second Item",
                            new EventHandler(this.PopUp_Selection));
      myPopUp.MenuItems.Add("-");
      myPopUp.MenuItems.Add("Third Item",
                            new EventHandler(this.PopUp_Selection));

      this.ContextMenu = myPopUp;
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
      MessageBox.Show( "You are done with the application", "Status");

   }
}
